
;---------------------------------------------------------------
;
;                   Pentagon-128
;                      KAZ-6
;
;                     fixed by dr.Titus
;
;---------------------------------------------------------------




;---------------------------------------------------------------
;
;                   
;
;---------------------------------------------------------------

                 ORG    $C7ED
                 
                 RET
PrintChar:
                 LD     HL,$C839
                 RLC    (HL)
                 RET    NC
TextPtr:         LD     HL,$CD8A                                ;     
                 LD     A,(HL)
                 CP     $FF
                 JR     NZ,SkipBeginText
                 LD     HL,$CD8A
                 LD     A,(HL)
SkipBeginText:   INC    HL
                 LD     (TextPtr + 1),HL
                 LD     BC,$3D00
                 LD     L,A
                 LD     H,C
                 ADD    HL,HL
                 ADD    HL,HL
                 ADD    HL,HL
                 CP     A,$5F
                 JR     C,BaseFont
                 LD     BC,$CA26
BaseFont:        ADD    HL,BC
                 LD     DE,$F13F
                 LD     B,8

                 ;    

                      
;---------------------------------------------------------------
;
;                          1
;
;---------------------------------------------------------------

                ORG     $C38E
Part1Tail:

                LD      HL,$F36F
P1_Counter:     LD      BC,$6001
P1_PalLoop:     LD      A,(HL)
                SUB     C
                JR      NC,P1_SkipZero
                XOR     A
P1_SkipZero:    LD      (HL),A
                INC     HL
                ADD     A,A
                ADD     A,A
                ADD     A,A
                LD      (HL),A
                INC     L
                DJNZ    P1_PalLoop

                ORG     $C3C8
                
                EI
                HALT
                LD      A,($828C)
                LD      DE,$4014
                CALL    $C77D
                CALL    PrintFixChar                            ;      
                CALL    $C796                                   ;       

                DUP     11
                NOP
                ENDDUP

                
;---------------------------------------------------------------
                
                ORG     $C43C
Part1:
                
                LD      BC,$d508
                LD      A,(BC)
                LD      A,(BC)
Delay1:         ADD     HL,HL
                DEC     B
                JR      NZ,Delay1

                CALL    ColorEngine
                JP      $C492

                DUP     71
                NOP
                ENDDUP

                ORG     $C497
                
                NOP
                NOP
                NOP

;---------------------------------------------------------------
;
;                          2
;
;---------------------------------------------------------------

                ORG     $C505

                CALL    PrintChar                               ;       

                ORG     $C51A
                LD      (P2_Stack + 1),SP

                ORG     $C572
Part2:
P2_Stack:       LD      SP,0
                CALL    $C796                                   ;       

                LD      BC,$3508
Delay2:         INC     HL
                DEC     B
                JR      NZ,Delay2

                CALL    ColorEngine
                JP      $C5C6

                DUP     65
                NOP
                ENDDUP


;---------------------------------------------------------------
;
;                          3
;
;---------------------------------------------------------------
                          
                ORG     $C63B

                DUP     12
                NOP
                ENDDUP

                EI
                HALT

                ORG     $C650
                LD      (SP3Save+1),SP
                
                ORG     $C70B
Part3:
SP3Save:        LD      SP,0

                CALL    PrintFixChar                            ;      
                CALL    $C796                                   ;       

                XOR     A
                RET     NZ
                
                LD      BC,$4c08
Delay3:         INC     HL
                DEC     B
                JR      NZ,Delay3

                CALL    ColorEngine

                LD      A,($828C)                               ;   (2600 )
                LD      DE,$4014                                ;
                CALL    $C77D                                   ;
                
                JP      $C762

                DUP     54
                nop
                ENDDUP


;---------------------------------------------------------------
;
;                          4
;
;---------------------------------------------------------------
                          
                ORG     $C8A4
                
                CALL    PrintChar                               ;       

                ORG     $C8B9

                LD      (SP4Save + 1),SP

                
                ORG     $C91A
Part4:
SP4Save:        LD      SP,0
                
                CALL    $C796                                   ;       

                LD      BC,$0508
Delay4:         INC     HL
                DEC     B
                JR      NZ,Delay4

                CALL    ColorEngine

                JP      $C972

;---------------------------------------------------------------

Part6FastCore:
                LD      DE,$0700
                LD      B,12
P6FC_Loop:
                LD      (HL),E
                INC     HL
                AND     D
                LD      (HL),A
                INC     L
                INC     A

                LD      (HL),E
                INC     L
                AND     D
                LD      (HL),A
                INC     L
                INC     A

                LD      (HL),E
                INC     L
                AND     D
                LD      (HL),A
                INC     L
                INC     A

                LD      (HL),E
                INC     L
                AND     D
                LD      (HL),A
                INC     L
                INC     A

                LD      (HL),E
                INC     L
                AND     D
                LD      (HL),A
                INC     L
                INC     A

                LD      (HL),E
                INC     L
                AND     D
                LD      (HL),A
                INC     L
                INC     A

                LD      (HL),E
                INC     L
                AND     D
                LD      (HL),A
                INC     L
                INC     A

                LD      (HL),E
                INC     L
                AND     D
                LD      (HL),A
                INC     L
                INC     A

                DJNZ    P6FC_Loop
                
                RET
                
                DUP     12
                nop
                ENDDUP



;---------------------------------------------------------------
;
;                          5
;
;---------------------------------------------------------------

                ORG     $C9A0

                CALL    PrintChar                               ;       

                ORG     $CA00

                LD      (SP5Save + 1),SP
                
                ORG     $CA10
Part5:
SP5Save:        LD      SP,0
                CALL    $C796                                   ;       

                NOP
                NOP
                
                LD      BC,$0c08
Delay5:         INC     HL
                DEC     B
                JR      NZ,Delay5

                CALL    ColorEngine

                JP      $CA66
                
                DUP     65
                nop
                ENDDUP

                
;---------------------------------------------------------------
;
;                          6
;
;---------------------------------------------------------------

                ORG     $CB1E

                CALL    Part6FastCore
                JP      $CB27
                          
                ORG     $CB4E
Part6:

                LD      A,($828D)

                EI
                HALT
                LD      DE,$4016
                CALL    $C77D
                CALL    $C796                                   ;       
                
                LD      HL,$CAE4
                LD      A,8
P6_Loop1:       EX      AF,AF'
                LD      B,0
                LD      C,(HL)
                EX      DE,HL
                LD      HL,$F470
                ADD     HL,BC
                LD      C,(HL)
                LD      HL,$F42C
                SBC     HL,BC
                INC     DE
                PUSH    DE
                PUSH    HL
                LD      HL,$F36F
                ADD     HL,BC
                PUSH    HL
                LD      A,(DE)
                LD      C,A
                LD      HL,$F4F0
                ADD     HL,BC
                POP     DE
                LD      BC,$05FF
P6_Loop2:       LDI
                LD      A,(DE)
                AND     $07
                OR      (HL)
                LD      (DE),A
                INC     HL
                INC     E
                DJNZ    P6_Loop2
                POP     DE
                LD      BC,$05FF
                DEC     HL
P6_Loop3:       LD      A,(DE)
                AND     A,$07
                OR      (HL)
                LD      (DE),A
                DEC     HL
                DEC     DE
                LDD
                DJNZ    P6_Loop3
                POP     HL
                INC     HL
                EX      AF,AF'
                DEC     A
                JR      NZ,P6_Loop1


                CALL    PrintFixChar

                NOP
                
                LD      BC,$8708
Delay6:         INC     HL
                DEC     B
                JR      NZ,Delay6

                CALL    ColorEngine

                JP      $CC01

                DUP     14
                NOP
                ENDDUP


;---------------------------------------------------------------

                ORG    $CBC2
PrintFixChar:
                LD     HL,$C839
                RLC    (HL)
                JR     C,PC_NextChar
                LD     B,33
PC_Delay:       NOP
                DJNZ   PC_Delay
                RET
PC_NextChar:
                LD     HL,(TextPtr + 1)
                LD     A,(HL)
                CP     A,$FF
                LD     DE,$CD8A
                JR     NZ,PC_SkipBegin                          ;  0..1 
                EX     DE,HL
PC_SkipBegin:   LD     A,(HL)
                INC    HL
                LD     (TextPtr + 1),HL
                LD     DE,$3D00
                LD     L,A
                LD     H,E
                ADD    HL,HL
                ADD    HL,HL
                ADD    HL,HL
                LD     B,H
                LD     C,L
                LD     HL,$CA26
                CP     A,$5F
                JR     NC,PC_ExtendFont                         ;  0..1 
                EX     DE,HL
PC_ExtendFont:  ADD    HL,BC
                LD     DE,$F13F
                LD     B,8
PC_Loop:        LD     A,(HL)
                RRCA
                OR     (HL)
                LD     (DE),A
                INC    L
                INC    E
                DJNZ   PC_Loop
                RET
 


;---------------------------------------------------------------
;
;                          7
;
;---------------------------------------------------------------

                ORG     $CC29
                LD      HL,$CB1D
                          
                ORG     $CC45
Part7:
                LD      A,($828C)
                LD      DE,$4014
                CALL    $C77D

                DUP     14
                NOP
                ENDDUP
                
                EI
                HALT

                LD      HL,$F36F
                LD      A,($CB1D)
                CALL    Part6FastCore
                
                CALL    PrintFixChar
                CALL    $C796                                   ;       

                LD      HL,$CAD4
                LD      A,8
P7_Loop2:       EX      AF,AF'
                LD      B,0
                LD      A,(HL)
                INC     A
                AND     A,$7F
                LD      (HL),A
                LD      C,A
                EX      DE,HL
                LD      HL,$F522
                ADD     HL,BC
                LD      C,(HL)
                INC     DE
                PUSH    DE
                LD      HL,$F36F
                ADD     HL,BC
                EX      DE,HL
                LD      C,(HL)
                LD      HL,$F5A2
                ADD     HL,BC
                LD      BC,$07FF
P7_Loop3:       LDI
                LD      A,(DE)
                AND     A,$07
                OR      (HL)
                LD      (DE),A
                INC     HL
                INC     E
                DJNZ    P7_Loop3
                POP     HL
                INC     HL
                EX      AF,AF'
                DEC     A
                JR      NZ,P7_Loop2

                LD      BC,$d008
                LD      A,(BC)
Delay7:         INC     HL
                DEC     B
                JR      NZ,Delay7

                CALL    ColorEngine
                XOR     A
                OUT     ($FE),A

                JP      $CD01

                
;---------------------------------------------------------------

                ORG     $CCB2
ColorEngine:
                LD      (CE_Stack + 1),SP

                LD      HL,$EFB7
                EXX
                LD      HL,$F36F
                LD      B,$60
CE_Loop:
                LD      A,(HL)
                INC     HL
                LD      E,(HL)
                LD      D,E
                INC     HL
                EXX
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
                INC     L
                INC     L
                INC     HL
                EX      DE,HL
                SET     3,L
                LD      SP,HL
                EX      (SP),HL
                EX      (SP),HL
                ADD     HL,BC
                LD      (CE_SP0 + 1),HL
                ADD     HL,BC
                LD      (CE_SP1 + 1),HL
                ADD     HL,BC
                LD      (CE_SP2 + 1),HL
                EX      DE,HL
                EXX
                RET     C

                PUSH    DE
                PUSH    DE
                PUSH    DE
                PUSH    DE
CE_SP0:        	LD      SP,0
                PUSH    DE
                PUSH    DE
                PUSH    DE
                PUSH    DE
CE_SP1:         LD      SP,0
                OUT     ($FE),A
                PUSH    DE
                PUSH    DE
                PUSH    DE
                PUSH    DE
CE_SP2:         LD      SP,0
                PUSH    DE
                PUSH    DE
                PUSH    DE
                PUSH    DE

                DJNZ    CE_Loop

CE_Stack:       LD      SP,0
                RET

;---------------------------------------------------------------







                      
